=== debian/control ===
Source: glite-lb-client
Priority: extra
Maintainer: CESNET Product Teams <emi-lb@metacentrum.cz>
Uploaders: František Dvořák <valtri@civ.zcu.cz>
Build-Depends: debhelper (>= 7.0.50~), libtool-bin, libclassad0-dev | libclassad-dev, glite-lb-types, libglite-jobid-api-c-dev, libglite-jobid-api-cpp-dev, libglite-lb-common-dev, libglite-lbjp-common-gss-dev, libglite-lbjp-common-trio-dev, pkg-config
Standards-Version: 3.9.1
Section: libs
Homepage: http://glite.cern.ch

Package: libglite-lb-client14
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gLite Logging and Bookkeeping client library
 glite-lb-client is the library implementing client side of gLite Logging and
 Bookkeeping
 API.

Package: libglite-lb-client-dev
Section: libdevel
Architecture: any
Provides: glite-lb-client
Depends: libglite-lb-client14 (= ${binary:Version}), ${misc:Depends}, libglite-lb-common-dev, libglite-jobid-api-c-dev, libglite-jobid-api-cpp-dev
Description: Development files for gLite L&B/JP common log module
 glite-lb-client is the library implementing client side of gLite Logging and
 Bookkeeping
 API.
 .
 This package contains development libraries and header files for gLite L&B
 client library.

Package: glite-lb-client-progs
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Description: gLite L&B client programs and examples
 glite-lb-client is the library implementing client side of gLite Logging and
 Bookkeeping
 API.
 .
 This package contains client programs and examples for gLite L&B.

Package: libglite-lb-client14-dbg
Section: debug
Architecture: any
Depends: libglite-lb-client14 (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for gLite L&B client library
 glite-lb-client is the library implementing client side of gLite Logging and
 Bookkeeping
 API.
 .
 This package contains debugging symbols for gLite L&B client library.

Package: glite-lb-client-progs-dbg
Section: debug
Architecture: any
Depends: glite-lb-client-progs (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for gLite L&B client tools
 glite-lb-client is the library implementing client side of gLite Logging and
 Bookkeeping
 API.
 .
 This package contains debugging symbols for gLite L&B client tools.
