=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

p_base=glite-lb-client
p_dev=libglite-lb-client-dev
p_lib=libglite-lb-client14
p_progs=glite-lb-client-progs

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel --fail-missing

override_dh_auto_configure: config.status
config.status:
	./configure --root=/ --prefix=/usr --libdir=lib --docdir=/usr/share/doc/$(p_base) --os-type=debian --project=emi

override_dh_auto_clean: config.status
	make clean

override_dh_clean:
	dh_clean
	rm -vf Makefile.inc config.status *.spec

override_dh_strip:
	dh_strip -p$(p_lib) --dbg-package=$(p_lib)-dbg
	dh_strip -p$(p_progs) --dbg-package=$(p_progs)-dbg

override_dh_auto_install:
	dh_auto_install
	rm -vf debian/tmp/usr/lib/*.la
	mkdir -p debian/$(p_dev)/usr/share/doc/$(p_dev)
	mkdir -p debian/$(p_progs)/usr/share/doc/$(p_progs)
	mv debian/tmp/usr/share/doc/$(p_base)/examples debian/$(p_dev)/usr/share/doc/$(p_dev)
	mv debian/tmp/usr/share/doc/$(p_base)/README-notify debian/$(p_progs)/usr/share/doc/$(p_progs)
	rm -rfv debian/tmp/usr/share/doc/$(p_base)

override_dh_installdocs:
	dh_installdocs -p $(p_dev)
	dh_installdocs -p $(p_lib)
	dh_installdocs -p $(p_progs)
	dh_installdocs -p $(p_lib)-dbg --link-doc=$(p_lib)
	dh_installdocs -p $(p_progs)-dbg --link-doc=$(p_lib)
