=== debian/watch ===
version=3
http://scientific.zcu.cz/emi/emi.lb.client/glite-lb-client-(.*)\.tar\.gz
